#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QMessageBox>
#include <QDebug>
#include <QSound>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{

    ui->setupUi(this);
    statusLed = new QLed(ui->verticalLayoutWidget);
    ui->horizontalLayout_4->insertWidget(0,statusLed);

    statusLed->setOnColor(QLed::Red);
    statusLed->setOffColor(QLed::Green);
    //statusLed->setGeometry(QRect(0,0,100,100));
    statusLed->setShape(QLed::Rounded);
    setCentralWidget(ui->verticalLayoutWidget);
    connect(&tread,SIGNAL(generate(int)),this,SLOT(cliccaBottone(int)));
    connect(&tread,SIGNAL(score(int)),ui->lcdNumber,SLOT(display(int)));
    connect(&tread,SIGNAL(exit(int)),this,SLOT(sbagliato(int)));
    connect(&tread,SIGNAL(disableInterface()),this,SLOT(disableAll()));
    connect(&tread,SIGNAL(enableInterface()),this,SLOT(enableAll()));
    connect(this,SIGNAL(cliccatoIlBottone(int)),&tread,SLOT(updateCaption(int)));
    connect(ui->pushButton,SIGNAL(clicked()),this,SLOT(clickA()));
    connect(ui->pushButton_2,SIGNAL(clicked()),this,SLOT(clickB()));
    connect(ui->pushButton_3,SIGNAL(clicked()),this,SLOT(clickC()));
    connect(ui->pushButton_4,SIGNAL(clicked()),this,SLOT(clickD()));
    connect(ui->pushButton_5,SIGNAL(clicked()),this,SLOT(clickE()));
    connect(ui->pushButton_6,SIGNAL(clicked()),this,SLOT(clickF()));
    connect(ui->pushButton_7,SIGNAL(clicked()),this,SLOT(clickG()));
    connect(ui->pushButton_8,SIGNAL(clicked()),this,SLOT(clickH()));
    connect(ui->pushButton_9,SIGNAL(clicked()),this,SLOT(clickI()));

    tread.start();

    setStyleSheet("CrazyButton {"
                 "color: white;"
                 "background-color: QLinearGradient( x1: 0, y1: 0, x2: 0, y2: 1, stop: 0 #88d, stop: 0.1 #99e, stop: 0.49 #77c, stop: 0.5 #66b, stop: 1 #77c);"
                 "border-width: 1px;"
                 "border-color: #339;"
                 "border-style: solid;"
                 "border-radius: 7;"
                 "padding: 3px;"
                 "font-size: 50px;"
                 "padding-left: 5px;"
                 "padding-right: 5px;"
                 "min-width: 15px;"
                 "max-width: 300px;"
                 "min-height: 11px;"
                 "max-height: 300px;"
                 "}"
                 "QPushButton:pressed {"
                 "padding-top: 15px;"
                 "}");
    //showMaximized();
}
void MainWindow::sbagliato(int score){
    QString sscore("Score ");
    sscore.append(QString::number(score));
    QMessageBox::warning(this, tr("End Game"),sscore,QMessageBox::Escape);
    //tread.genera();
    exit(0);

}
void MainWindow::disableAll(){
    ui->pushButton->setEnabled(false);
    ui->pushButton_2->setEnabled(false);
    ui->pushButton_3->setEnabled(false);
    ui->pushButton_4->setEnabled(false);
    ui->pushButton_5->setEnabled(false);
    ui->pushButton_6->setEnabled(false);
    ui->pushButton_7->setEnabled(false);
    ui->pushButton_8->setEnabled(false);
    ui->pushButton_9->setEnabled(false);
    statusLed->setValue(true);
}

void MainWindow::enableAll(){
    ui->pushButton->setEnabled(true);
    ui->pushButton_2->setEnabled(true);
    ui->pushButton_3->setEnabled(true);
    ui->pushButton_4->setEnabled(true);
    ui->pushButton_5->setEnabled(true);
    ui->pushButton_6->setEnabled(true);
    ui->pushButton_7->setEnabled(true);
    ui->pushButton_8->setEnabled(true);
    ui->pushButton_9->setEnabled(true);
    statusLed->setValue(false);
}


void MainWindow::cliccaBottone(int id)
{
    switch(id){
        case 0:
                if(ui->pushButton->getStateColor())
                    QSound::play("sounds/dog.wav");
                ui->pushButton->changeColor();
                break;
        case 1:
                if(ui->pushButton_2->getStateColor())
                    QSound::play("sounds/cat.wav");
                ui->pushButton_2->changeColor();
                break;
        case 2:
                if(ui->pushButton_3->getStateColor())
                    QSound::play("sounds/cow.wav");
                ui->pushButton_3->changeColor();
                break;
        case 3:
                if(ui->pushButton_4->getStateColor())
                    QSound::play("sounds/duck.wav");
                ui->pushButton_4->changeColor();
                break;
        case 4:
                if(ui->pushButton_5->getStateColor())
                    QSound::play("sounds/goat.wav");
                ui->pushButton_5->changeColor();
                break;
        case 5:
                if(ui->pushButton_6->getStateColor())
                    QSound::play("sounds/donkey.wav");
                ui->pushButton_6->changeColor();
                break;
        case 6:
                if(ui->pushButton_7->getStateColor())
                    QSound::play("sounds/crow.wav");
                ui->pushButton_7->changeColor();
                break;
        case 7:
                if(ui->pushButton_8->getStateColor())
                    QSound::play("sounds/rosteer.wav");
                ui->pushButton_8->changeColor();
                break;
        case 8:
                if(ui->pushButton_9->getStateColor())
                    QSound::play("sounds/bleeeh.wav");
                ui->pushButton_9->changeColor();
                break;
    }
}

MainWindow::~MainWindow()
{
    delete ui;
}
void MainWindow::clickA(){
    QSound::play("sounds/dog.wav");
    emit cliccatoIlBottone(0);

}

void MainWindow::clickB(){
    QSound::play("sounds/cat.wav");
    emit cliccatoIlBottone(1);

}
void MainWindow::clickC(){
    QSound::play("sounds/cow.wav");
    emit cliccatoIlBottone(2);

}
void MainWindow::clickD(){
    QSound::play("sounds/duck.wav");
    emit cliccatoIlBottone(3);

}
void MainWindow::clickE(){
    QSound::play("sounds/goat.wav");
    emit cliccatoIlBottone(4);

}
void MainWindow::clickF(){
    QSound::play("sounds/donkey.wav");
    emit cliccatoIlBottone(5);

}
void MainWindow::clickG(){
    QSound::play("sounds/crow.wav");
    emit cliccatoIlBottone(6);

}
void MainWindow::clickH(){
    QSound::play("sounds/rosteer.wav");
    emit cliccatoIlBottone(7);

}
void MainWindow::clickI(){
    QSound::play("sounds/bleeeh.wav");
    emit cliccatoIlBottone(8);

}


void MainWindow::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

